/********************************************************
 *  X2X.C
 *              Zeilenende-Korrektor
 *              ====================
 *
 *  27.08.97    Bodo Wenzel     V1.0, Erstellung
 *  28.08.97    Bodo Wenzel     V1.1, Einzelbyte-Bug
 *  04.02.98    Bodo Wenzel     V2.0, Statistik
 *  18.04.98    Bodo Wenzel     V2.1, auch [outfile]
 ********************************************************/

#include <ctype.h>
#include <stdio.h>

static int statistic(FILE *s) {
/*---------------------------*/
int  c;
long nd,nu,nm;

nd=nu=nm=0;
for (;;) {
  c=getc(s);
  if (c==EOF)
    break;
  if (c=='\r') {
    c=getc(s);
    if (c=='\n')
      nd++;
    else {
      ungetc(c,s);
      nm++;
      }
  } else if (c=='\n')
    nu++;
  }
if (ferror(s))
  puts("warning: read error with source");
printf("d(\\r\\n)=%ld u(\\n)=%ld m(\\r)=%ld\n",nd,nu,nm);
return(0);
}

static int x2x(char i,char o,FILE *s,FILE *d) {
/*-------------------------------------------*/
int  c;

if (i!='D' && i!='U' && i!='M') {
  puts("from what?!");
  return(2);
  }
if (o!='D' && o!='U' && o!='M') {
  puts("to what?!");
  return(2);
  }

for (;;) {
  c=getc(s);
  if (c==EOF)
    break;
  if (i=='D' && c=='\r') {
    c=getc(s);
    if (c=='\n')
      c=EOF;
    else {
      ungetc(c,s);
      c='\r';
      }
  } else if (i=='U' && c=='\n')
    c=EOF;
  else if (i=='M' && c=='\r')
    c=EOF;

  if (c==EOF)
    switch (o) {
    case 'D':
      fputc('\r',d);
      fputc('\n',d);
      break;
    case 'U':
      fputc('\n',d);
      break;
    case 'M':
      fputc('\r',d);
      break;
    }
  else
    fputc(c,d);
  if (ferror(d)) {
    puts("warning: write error with source");
    break;
    }
  }
if (ferror(s))
  puts("warning: read error with source");
return(0);
}

int main(int argc,char *argv[]) {
/*-----------------------------*/
FILE *s,*d;
char *n;
int  r;

switch (argc) {
case 2:
  s=fopen(argv[1],"rb");
  if (s==NULL) {
    puts("what about the file?!");
    return(2);
    }
  r=statistic(s);
  fclose(s);
  break;
case 3:
  n=tmpnam(NULL);
  s=fopen(argv[2],"rb");
  if (s==NULL) {
    puts("what about the file?!");
    return(2);
    }
  d=fopen(n,"wb");
  if (d==NULL) {
    puts("can't create a tempfile?!");
    return(2);
    }
  r=x2x(toupper(argv[1][0]),toupper(argv[1][2]),s,d);
  fclose(s);
  fclose(d);
  if (remove(argv[2])!=0) {
    puts("can't remove the file?!");
    return(2);
    }
  if (rename(n,argv[2])!=0) {
    puts("can't rename the file?!");
    return(2);
    }
  break;
case 4:
  s=fopen(argv[2],"rb");
  d=fopen(argv[3],"wb");
  if (s==NULL || d==NULL) {
    puts("what about the files?!");
    return(2);
    }
  r=x2x(toupper(argv[1][0]),toupper(argv[1][2]),s,d);
  fclose(s);
  fclose(d);
  break;
default:
  puts("X2X DOS/UN*X/MAC Converter V2.1\n"
       "usage: X2X <file>\n"
       "       X2X <d|u|m>2<d|u|m> <file>\n"
       "       X2X <d|u|m>2<d|u|m> <infile> <outfile>");
  return(1);
  }
return(r);
}

/* === Ende =========================================== */
